clc
clear
%close all
clf

%Folder containing all videos to be processed
MegaFold = 'C:\Data\VideosAsImages\Date';

%A background image to correct for any stains/dust on the camera or lens
BG = imread('Z:\MFData\ConvertedSets\7_12_16\bg_6_17_16.tiff');


MFd = dir(MegaFold);

%Loop over all folders and files in MegaFold
for k = 3:length(MFd)
    %The folder containing one set of related videos
    ScanFoldd  = dir([MegaFold '\' MFd(k).name]);
    
    %loop over all the folders in ScanFoldd
    for g = 3:length(ScanFoldd);
        FoldName = ScanFoldd(g).name;
        %The folder containing one video of 
        InFold = [MegaFold '\' MFd(k).name '\' FoldName];
        if isdir(InFold) == 0
            continue
        end
        
        %extract the background image
        [BGimg,Inimg] = KosBG(InFold);
        
        %Create a devignetting filter
        FiltSource = KosFirstImg(InFold);
        Filter = medfilt2(FiltSource,[50 50]);
        %Filter = load('7_12_16_Filter');
        %Filter = Filter.Filter;
        
        Thresh = 0.15;
        while isempty(Thresh) == 0
            [RBCs,Fimg,Toimg,Trimg,Foimg] = KosFindTest(BGimg,Filter,BG,Thresh);
            Grph = OtherPlot(RBCs,Fimg);
            fprintf('\n')
            fprintf([MFd(k).name '->' FoldName])
            fprintf('\n There are %i detected cells',length(RBCs));
            Thresh = input('\nRedo with new Thresh: ');
            if isempty(Thresh) == 0
                if Thresh >= 1 || Thresh <= 0
                    Thresh = 0.15;
                    fprintf('\nThat''s a problem!\n')
                end
            end
        end
        FinalCount = input('\nInput the adjustment: ');
        FinalCount = length(RBCs) + FinalCount;
        clc
        fprintf('\n')
        fprintf(['The final count for ' MFd(k).name '->' FoldName ' is: ' num2str(FinalCount)])
        fprintf('\n\n')
        imwrite(Grph,[InFold '\' FoldName '_BG.png']), save([InFold '\' FoldName '_RBCs.m'],'RBCs')
    end
end