function KosTrack(Foldpath,BG)

if nargin == 0
    Foldpath=uigetdir;
end

clc
%clear
%Foldpath='Z:\MFData\ConvertedSets\3_2_16\cosine1_2s';
IBWlist=getAllFiles(Foldpath);
Video=1;
n=0;

for k=1:length(IBWlist)
    if wrev(IBWlist{k}(length(IBWlist{k}):-1:length(IBWlist{k})-3))=='.tif'
        n=n+1;
        ReadList{n}=IBWlist{k};
    end
end

fprintf('Reading First Image\n')
IMG=imread(ReadList{1});
lightinglimits(2) = max(max(double(IMG)));
lightinglimits(1) = min(min(double(IMG)));

fprintf('Median Filter Calcuation\n')
Filter=medfilt2(IMG,[75 75]);
fprintf('Processing image 1\n')
if Video==1
    [RBCs{1},Gr]=KosFind(IMG,Filter,BG,lightinglimits);
    fprintf('Preallocating Memory For Video\n')
    Grph=OtherPlot(RBCs{1},Gr);
    mkdir([Foldpath '\output2\']);
    imwrite(Grph,[Foldpath '\output2\image_' num2str(1) '.png']);
    %Grph=uint8(zeros([size(G1), n]));
    %Grph(:,:,:,1)=G1;
else
    [RBCs{1}]=KosFind(IMG,Filter,BG,lightinglimits);
end
cellsn=length(RBCs{1,1});
cold=cat(1, RBCs{1}.Centroid);


for k=2:n
    clc
    fprintf('Processing image %i from: ',k)
    disp(['Processing image ' Foldpath])
    fprintf('\n')
    IMG=imread(ReadList{k});
    if Video==1
        [RBCsnew,Gr]=KosFind(IMG,Filter,BG,lightinglimits);
    else
        [RBCsnew]=KosFind(IMG,Filter,BGF,lightinglimits);
    end
    cnew=cat(1, RBCsnew.Centroid);
    
    %Search for nearest object
    [ind, d]=dsearchn(cold,cnew);
    
    %clear original map
    cold=[];
    
    %remove unique mapings
    for l=1:length(ind)
        gl=find(ind==l);
        if length(gl)>1
            [tempd, teri]=min(d(gl));
            teri=gl(teri);
            d(gl)=Inf;
            d(teri(1))=tempd;
        end
    end
    
    %map to previous image
    for i=1:length(ind)
        if d(i)<50
            RBCsnew2(ind(i)).Area=[RBCsnew(i).Area];
            RBCsnew2(ind(i)).Centroid=[RBCsnew(i).Centroid];
            RBCsnew2(ind(i)).MajorAxisLength=[RBCsnew(i).MajorAxisLength];
            RBCsnew2(ind(i)).MinorAxisLength=[RBCsnew(i).MinorAxisLength];
            RBCsnew2(ind(i)).Orientation=[RBCsnew(i).Orientation];
        else
            cellsn=cellsn+1;
            RBCsnew2(cellsn).Area=[RBCsnew(i).Area];
            RBCsnew2(cellsn).Centroid=[RBCsnew(i).Centroid];
            RBCsnew2(cellsn).MajorAxisLength=[RBCsnew(i).MajorAxisLength];
            RBCsnew2(cellsn).MinorAxisLength=[RBCsnew(i).MinorAxisLength];
            RBCsnew2(cellsn).Orientation=[RBCsnew(i).Orientation];
        end
    end
    
    %save this map for next image
    b=length(RBCsnew2);
    trig=0;
    
    if cellsn>(b)
        RBCsnew2(cellsn+1).Area=[NaN];
        trig=1;
    end
    
    for nk=1:cellsn
        if isempty(RBCsnew2(nk).Centroid)
            cold(nk,:)=[NaN NaN];
        else
            cold(nk,:)=RBCsnew2(nk).Centroid;
        end
    end
    
    if trig==1
        RBCsnew2(cellsn+1).Area=[];
    end
    
    if Video==1
        fprintf('Saving video frame\n')
        Grph=OtherPlot(RBCsnew2,Gr);
        imwrite(Grph,[Foldpath '\output2\image_' num2str(k) '.png']);
    end
    RBCs{k}=RBCsnew2;
    clear RBCsnew2
end

save([Foldpath '\RBCs.mat'],'RBCs')

end